"use strict";
var camelCase = require('camelcase');
var core_1 = require('../core');
var bootstrap_1 = require('../extensions/bootstrap');
function bootstrapComponent(ngModule, declaration) {
    var metadata = Reflect.getMetadata('ngms:component', declaration.prototype);
    var data = {
        controller: declaration
    };
    if (metadata.template) {
        data.template = metadata.template;
    }
    else if (metadata.templateUrl) {
        data.templateUrl = metadata.templateUrl;
    }
    if (metadata.controllerAs) {
        data.controllerAs = metadata.controllerAs;
    }
    var injector = bootstrap_1.bootstrapInject(declaration);
    var properties = bootstrap_1.bootstrapProperty(declaration);
    var transclude = bootstrap_1.bootstrapTransclude(declaration);
    if (injector) {
        if (injector.hasCommon) {
            injector.injectCommon(declaration);
        }
        if (injector.hasProperties) {
            injector.injectProperties(declaration.prototype, ngModule);
        }
    }
    if (properties) {
        data.bindings = properties;
    }
    if (transclude) {
        data.transclude = transclude;
    }
    var name = camelCase(metadata.selector);
    ngModule.component(name, data);
    core_1.NgmsReflect.defineMetadata(declaration, 'component', Object.assign({
        name: name,
        controllerAs: '$ctrl'
    }, data));
}
exports.bootstrapComponent = bootstrapComponent;
//# sourceMappingURL=D:/Creation/1.Programming/javascript/ng-metasys/src/component/bootstrap-component.js.map