"use strict";
var core_1 = require('../core');
var bootstrap_1 = require('../extensions/bootstrap');
var bootstrap_link_1 = require('./bootstrap-link');
var parse_selector_1 = require('./parse-selector');
function bootstrapDirective(ngModule, declaration) {
    var metadata = Reflect.getMetadata('ngms:directive', declaration.prototype);
    var data = {
        controller: declaration,
        scope: true
    };
    if (metadata.template) {
        data.template = metadata.template;
    }
    else if (metadata.templateUrl) {
        data.templateUrl = metadata.templateUrl;
    }
    if (metadata.controllerAs) {
        data.controllerAs = metadata.controllerAs;
    }
    else {
        data.controllerAs = '$ctrl';
    }
    var injector = bootstrap_1.bootstrapInject(declaration);
    var properties = bootstrap_1.bootstrapProperty(declaration);
    var transclude = bootstrap_1.bootstrapTransclude(declaration);
    var link = bootstrap_link_1.bootstrapLink(declaration);
    if (injector) {
        if (injector.hasCommon) {
            injector.injectCommon(declaration);
        }
        if (injector.hasProperties) {
            injector.injectProperties(declaration.prototype, ngModule);
        }
    }
    if (properties) {
        data.bindToController = properties;
    }
    if (transclude) {
        data.transclude = transclude;
    }
    if (link) {
        data.link = declaration[link];
    }
    var _a = parse_selector_1.parseSelector(metadata.selector), name = _a[0], restrict = _a[1];
    data.restrict = restrict;
    ngModule.directive(name, function () { return data; });
    core_1.NgmsReflect.defineMetadata(declaration, 'directive', Object.assign({ name: name }, data));
}
exports.bootstrapDirective = bootstrapDirective;
//# sourceMappingURL=D:/Creation/1.Programming/javascript/ng-metasys/src/directive/bootstrap-directive.js.map