import * as angular from 'angular';
export declare class DeclarationInjector {
    private _common;
    private _methods;
    private _properties;
    constructor({common, methods, properties}: {
        common?: string[];
        methods?: {
            [method: string]: string[];
        };
        properties?: {
            [property: string]: string;
        };
    });
    readonly hasCommon: boolean;
    readonly hasMethods: boolean;
    readonly hasProperties: boolean;
    injectCommon(declaration: any): void;
    injectMethods(declaration: any, methodName: string): void;
    injectProperties(declaration: any, ngModule: angular.IModule): void;
}
export declare function bootstrapInject(declaration: any): DeclarationInjector;
