"use strict";
function moduleConfigDecoratorFactory(type) {
    return function (declaration, property) {
        if (typeof declaration !== 'function') {
            throw new Error(property + " of module " + declaration.name + " should be static");
        }
        var namespace = "ngms:module:" + type;
        if (!Reflect.hasMetadata(namespace, declaration)) {
            Reflect.defineMetadata(namespace, [property], declaration);
            return;
        }
        Reflect.getMetadata(namespace, declaration).push(property);
    };
}
exports.moduleConfigDecoratorFactory = moduleConfigDecoratorFactory;
//# sourceMappingURL=D:/Creation/1.Programming/javascript/ng-metasys/src/module/module-config-decorator-factory.js.map