"use strict";
var bootstrap_1 = require('../extensions/bootstrap');
var core_1 = require('../core');
function bootstrapFactory(ngModule, declaration) {
    if (!declaration.$get) {
        throw new Error("Factory " + declaration.name + " should have static method '$get'");
    }
    var inject = bootstrap_1.bootstrapInject(declaration);
    if (inject && inject.hasMethods) {
        inject.injectMethods(declaration, '$get');
    }
    ngModule.factory(declaration.name, declaration.$get);
    core_1.NgmsReflect.defineMetadata(declaration, 'factory', {
        name: declaration.name,
        instance: declaration.$get
    });
}
exports.bootstrapFactory = bootstrapFactory;
//# sourceMappingURL=D:/Creation/1.Programming/javascript/ng-metasys/src/providers/bootstrap-factory.js.map