"use strict";
var bootstrap_1 = require('../extensions/bootstrap');
var core_1 = require('../core');
function bootstrapProvider(ngModule, declaration) {
    if (!declaration.prototype.$get) {
        throw new Error("Provider " + declaration.name + " should have method '$get'");
    }
    var inject = bootstrap_1.bootstrapInject(declaration);
    if (inject && inject.hasMethods) {
        inject.injectMethods(declaration.prototype, '$get');
    }
    ngModule.provider(declaration.name, declaration);
    core_1.NgmsReflect.defineMetadata(declaration, 'provider', {
        name: declaration.name,
        instance: declaration
    });
}
exports.bootstrapProvider = bootstrapProvider;
//# sourceMappingURL=D:/Creation/1.Programming/javascript/ng-metasys/src/providers/bootstrap-provider.js.map